  DEFINT I-K
  DEFDBL A-H, O-Z
'                       MMX.BAS
'       Revision 1.0    Original                         22 DEC 2000
'       Revision 1.1                                     11 MAR 2015
  CONST Black = 0, Gray = 7, Yellow = 14, White = 15       ' 2015
  SCREEN 12
  DIM SHARED array%(170, 170)
  DIM SHARED itype, itypeold
  DIM stype AS STRING
  trace = 0
  isize = 170
  pi = 4 * ATN(1)
  vmax = 0
  xoffset = 1
  itypeold = 0
  LOCATE 1, 20: PRINT "MICHELSON and MORLEY'S EXPERIMENT"
  COLOR 15
  INPUT "Type -7 to -1, 1 to 7"; stype               ' 2015
  GOTO astr1

astr:
  COLOR 15
  INPUT "Type -7 to -1, 1 to 7 or R"; stype               ' 2015
astr1:
  IF UCASE$(stype) <> "R" THEN
     itype = VAL(stype)
  ELSE
     itype = itypedisp
  END IF
  itypedisp = itype                                  ' 2015
  IF itype > 0 THEN
    tdilution = 0
    IF lcontract = 0 OR itype <> itypeold THEN
      lcontract = 1
    ELSE
      lcontract = 0
    END IF
    itypeold = itype
  ELSE
    lcontract = 0                                    ' 2015
    IF tdilution = 1 OR itype <> itypeold THEN
      tdilution = 0
    ELSE
      tdilution = 1
    END IF
    itypeold = itype
    itype = -itype
  END IF
  vmax = 0              ' No movie
  CLS
  COLOR 7
  LOCATE 1, 20: PRINT "MICHELSON and MORLEY'S EXPERIMENT";
  IF lcontract = 1 THEN COLOR 14 ELSE COLOR 15         ' 2015
  LOCATE 1, 55:
  PRINT "LENGTH CONTRACTION ";
  IF lcontract = 1 THEN PRINT ; "ON" ELSE PRINT ; "OFF"
  LOCATE 2, 55:
  IF tdilution = 1 THEN COLOR 14 ELSE COLOR 15         ' 2015
  PRINT "TIME DILUTION ";
  IF tdilution = 1 THEN PRINT "ON" ELSE PRINT "OFF"
  SELECT CASE itype
  CASE IS = 1
    cyclecount = 10
    c = 100
    v = 0:
    dspiegel = 100
    dispf = 5
    lambda = 4
    xoffset = 1
  CASE IS = 2
    cyclecount = 10
    c = 100
    v = 15:
    dspiegel = 100
    dispf = 5
    lambda = 4
    xoffset = 1
  CASE IS = 3
    cyclecount = 10
    c = 100
    v = 15:
    dspiegel = 100
    dispf = 5
    lambda = 4
    xoffset = 0
  CASE IS = 4
    c = 30000000000#       '300000 km   300000 00000 cm/sec
    v = 6000000            '60 km = 60 000000 cm/sec
    dspiegel = 1100
    dispf = 800000
    lambda = .000059#     ' cm
    cyclecount = 20
    xoffset = 1
  CASE IS = 5
    c = 30000000000#       '300000 km   300000 00000 cm/sec
    v = 6000000            '60 km = 60 000000 cm/sec
    vmax = v
    dspiegel = 1100
    dispf = 800000
    lambda = .000059#     ' cm
    cyclecount = 10
    xoffset = 1
  CASE IS = 6
    c = 30000000000#       '300000 km   300000 00000 cm/sec
    v = 60 * 100000        '60 km = 60 000000 cm/sec
    vmax = v
    dspiegel = 1100
    dispf = 200
    lambda = .000059#     ' cm
    lambda = lambda * 1000
    cyclecount = 5
    xoffset = 0
  CASE IS = 7
    c = 30000000000#       '300000 km   300000 00000 cm/sec
    v = 2000000000#         '60 km = 60 000000 cm/sec
    dspiegel = 1100
    dispf = 400 / dspiegel
    lambda = .000059#     ' cm
    cyclecount = 10
    xoffset = 1
    IF itype = 7 THEN GOTO MMX100
  CASE ELSE
    END
  END SELECT
 
  x = 60 / (dspiegel * dispf)
  alpha1 = ATN(x) * 180 / pi
  dt = lambda / c
 
  xbase = 300: ybase = 280
 
  COLOR 14
  x0 = xbase + x
  y0 = ybase - y
    
  dalpha = alpha1 / 150
  dt = lambda / c
  l = 3 * dspiegel * SIN(alpha1 * pi / 180)
  dtbase = l / c
 
  LOCATE 4, 60
  IF vmax = 0 THEN
     ivmax = 0
     PRINT SPACE$(10)
  ELSE
     ivmax = 6
     COLOR 7: PRINT "Movie"
  END IF
  time1 = TIMER
 
  ' Start simulation as a function of speed
 
  FOR iv = 0 TO ivmax
    COLOR 15
    LOCATE 2, 1
    IF vmax <> 0 THEN v = iv * vmax / 6
    Beta = v / c
    COLOR 7: PRINT "lambda "; lambda; "  "
    COLOR 15: LOCATE 2, 17: PRINT USING "Beta #.########"; Beta
    LOCATE 3, 60: PRINT "type "; itypedisp                 ' 2015
    COLOR 7: LOCATE 3, 1: PRINT "c "; c / 100000;
    COLOR 15: LOCATE 3, 16: PRINT "v "; v / 100000; "km/sec"
    IF vmax <> 0 THEN
      LOCATE 4, 60
      COLOR 7: PRINT "Movie frame "; iv + 1
    END IF
    l100 = 0
    dspiegelx = dspiegel
    dspiegely = dspiegel

    IF xoffset = 0 THEN l100 = v * dispf * 2 * dspiegel / c
    '  hoek1 = ATN(x/y)
    hoek1 = ATN((v * dspiegelx / c) / dspiegely)
    hoek1 = 180 * hoek1 / pi
     
    ' dspiegel + v * tv = c * tv
    ' v * tw + c * tw = dspiegel
    dspiegelxx = dspiegelx
    IF lcontract = 1 THEN dspiegelxx = dspiegelx * SQR(1 - v * v / (c * c))
    tv = dspiegelxx / (c - v)
    tw = dspiegelxx / (c + v)
    tvw = tv + tw
   
    t1 = (2 * dspiegelx / c) * (1 / SQR(1 - v * v / (c * c)))
    t2 = dspiegelx / (c - v) + dspiegelx / (c + v)
    COLOR 7
    IF trace = 1 THEN LOCATE 28, 67: PRINT USING "##.####"; c * (t2 - t1) / lambda;
   
    ' Perform simulation for different phases

    FOR count = 0 TO cyclecount - 1
      COLOR 7
      tbase = 2 * dspiegely / c
      tstr0 = tbase - dtbase: tend0 = tbase + dtbase
      tstr = tstr0 + count * dt / cyclecount
      tend = tend0 + count * dt / cyclecount

      ' Vertical ray - Horizontal mirror

      FOR alpha = 90 - hoek1 - alpha1 TO 90 - hoek1 + alpha1 STEP dalpha
        FOR t = tstr TO tend STEP dt
          r = c * t
          a = (alpha / 360) * 2 * pi
          x = r * COS(a): y = r * SIN(a)
          delta = dspiegely - y                     ' mirror y
          IF delta < 0 THEN y = dspiegely + delta
          IF xoffset = 1 THEN x = x - v * t
          x = x * dispf
          y = y * dispf
          ix = x - l100 + isize / 2
          iy = y + isize / 2
          IF ix >= 0 AND ix <= isize AND iy >= 0 AND iy <= isize THEN
            IF array%(ix, iy) = 0 THEN array%(ix, iy) = Gray
          END IF
          xdisp = xbase + x
          ydisp = ybase - y
          IF ABS(t - t1) < .5 * dt / cyclecount THEN
            COLOR White
            IF ix >= 0 AND ix <= isize AND iy >= 0 AND iy <= isize THEN
              array%(ix, iy) = White
            END IF
          ELSE
            COLOR Gray
          END IF
          IF iv = 0 THEN PSET (xdisp, ydisp)
        NEXT t
      NEXT alpha
  

      ' Horizontal ray - Vertical mirror

      tbase = 2 * dspiegelx / c
      tstr0 = tbase - dtbase: tend0 = tbase + dtbase
      tstr = tstr0 + count * dt / cyclecount
      tend = tend0 + count * dt / cyclecount
 
      FOR alpha = -alpha1 TO alpha1 STEP dalpha
        FOR t = tstr TO tend STEP dt
          t0 = t
          IF tdilution = 1 THEN t0 = t / SQR(1 - v * v / (c * c))
          r = c * t0
          a = (alpha / 360) * 2 * pi
          x = r * COS(a): y = r * SIN(a)
          d0 = dspiegelxx
          c1al = y / x
          Betax = 1 + c1al
          aa = c * c - Betax * v * v
          B = -2 * Betax * d0 * v
          cc = -Betax * d0 * d0
          w = SQR(B * B - 4 * aa * cc)
          tv1 = (-B + w) / (2 * aa)
          ' tv2 = (-B - w) / (2 * aa)
          dspiegel1 = d0 + v * tv1
          ' dspiegel2 = d0 + v * tv2
          delta = dspiegel1 - x
          IF delta < 0 THEN x = dspiegel1 + delta
          IF xoffset = 1 THEN x = x - v * t0           ' From current origin
          x = x * dispf
          y = y * dispf
          ix = x - l100 + isize / 2
          iy = y + isize / 2
          IF ix >= 0 AND ix <= isize AND iy >= 0 AND iy <= isize THEN
                array%(ix, iy) = array%(ix, iy) + 1
          END IF
          xdisp = xbase + x
          ydisp = ybase - y
          IF ABS(t - t1) < .5 * dt / cyclecount THEN
            COLOR White
            IF ix >= 0 AND ix <= isize AND iy >= 0 AND iy <= isize THEN
              array%(ix, iy) = White
            END IF
          ELSE
            IF ix >= 0 AND ix <= isize AND iy >= 0 AND iy <= isize THEN
              IF array%(ix, iy) > Gray THEN
                array%(ix, iy) = White
                COLOR Yellow
              ELSE
                COLOR Gray
              END IF
            ELSE
              COLOR Gray
            END IF
          END IF
          IF iv = 0 THEN
            PSET (xdisp, ydisp)
          END IF
        NEXT t
      NEXT alpha
    

skip2:       

      ' Clear interference pattern for all gray points
     
      FOR ix = 0 TO isize
        FOR iy = 0 TO isize
           IF array%(ix, iy) <> White THEN array%(ix, iy) = 0
        NEXT iy
      NEXT ix
 
      COLOR 4
      x0 = xbase
      IF xoffset = 0 THEN x0 = xbase + v * dispf * 2 * dspiegel / c
      y0 = ybase
    FOR x00 = x0 - 1 TO x0 + 1
      FOR y00 = y0 - 1 TO y0 + 1
        PSET (x00, y00)
      NEXT y00
    NEXT x00
  
        time3 = TIMER
        DO: LOOP UNTIL TIMER > time3
                                    
    NEXT count

   
    ' Display interference pattern
    time3 = TIMER
    DO: LOOP UNTIL TIMER > time3 + .2
   
    FOR ix = 0 TO isize
      FOR iy = 0 TO isize
        x = ix - isize / 2
        y = iy - isize / 2
        xdisp = xbase + x
        ydisp = ybase - y
        IF itype = 6 AND iv > 0 AND ix = 0 AND iy = 0 THEN
          LINE (xdisp - 15 + l100, ydisp)-(xdisp + l100, ybase + y), 0, BF
        END IF
        IF array%(ix, iy) = White THEN
          COLOR Yellow   ' array%(ix, iy)
        ELSE
          COLOR Black
        END IF
        PSET (xdisp + l100, ydisp)
        array%(ix, iy) = 0
      NEXT iy
    NEXT ix
 
    COLOR 4
    x0 = xbase
      IF xoffset = 0 THEN x0 = xbase + v * dispf * 2 * dspiegel / c
    y0 = ybase
    FOR x00 = x0 - 1 TO x0 + 1
      FOR y00 = y0 - 1 TO y0 + 1
        PSET (x00, y00)                                    ' 2015
      NEXT y00
    NEXT x00

  NEXT iv
 
  IF vmax > 0 THEN
    LOCATE 4, 60
    COLOR 15
    COLOR 7: PRINT "Movie end"; SPACE$(5)
  END IF
  Time2 = TIMER                                            ' 2015
  COLOR Gray
  IF trace = 1 THEN LOCATE 29, 67: PRINT USING "##.####"; Time2 - time1;
  LOCATE 4, 1
  GOTO astr

MMX100:
  xbase = 150: ybase = 450
      dspiegelx = dspiegel
      dspiegely = dspiegel
      tref = dspiegel / c
      dspiegelxx = dspiegelx
      IF lcontract = 1 THEN dspiegelxx = dspiegelx * SQR(1 - v * v / (c * c))
      tv = dspiegelxx / (c - v)
      tw = dspiegelxx / (c + v)
      tvw = tv + tw
   
    hoek1 = ATN((v * dspiegelx / c) / dspiegely)
    hoek1 = 180 * hoek1 / pi
 
  FOR it = 0 TO 120
    t = tvw * it / 120
    FOR alpha = 0 TO 90 STEP 1
          r = c * t
          a = (alpha / 360) * 2 * pi
          x = dspiegel * COS(a): y = dspiegel * SIN(a)
          x1 = x + tref * v
          'PRINT x, x1, y: END
          IF x1 > 0 THEN
            phi = ATN(y / x1)
          ELSE
            phi = 0
          END IF
          y1 = y
          d1 = SQR(x1 * x1 + y1 * y1)
          IF r <= d1 THEN
            x2 = r * COS(phi)
            y2 = r * SIN(phi)
            COLOR 7
          ELSE
            delta = r - d1
            x1 = x - tref * v
            'PRINT x, x1, y: END
            IF x1 = 0 THEN
              phi = pi / 2
            ELSE
              phi = ATN(y / x1)
              IF x1 > 0 THEN
                phi = phi
              ELSE
                phi = pi + phi
              END IF
            END IF
            y1 = y
            d1 = SQR(x1 * x1 + y1 * y1)
            d1 = d1 - delta
            x2 = 2 * tref * v + d1 * COS(phi)
            y2 = d1 * SIN(phi)
            COLOR 14
          END IF
          ' x2 = x2 - v * t
          x2 = x2 * dispf
          y2 = y2 * dispf
          xdisp = xbase + x2
          ydisp = ybase - y2
          PSET (xdisp, ydisp)
    NEXT alpha
  NEXT it
  GOTO astr

